from offline_results.recommendation.homepage_cluster_category.hompage_id_recommendation.data_gathering import \
    DataGathering
from offline_results.recommendation.homepage_cluster_category.hompage_id_recommendation.data_preperation import \
    DataPreprocessing
from offline_results.recommendation.homepage_cluster_category.hompage_id_recommendation.model_training import \
    ClassificationModel

from pandas import DataFrame
from offline_results.common.constants import HOMEPAGE_ID, S3
import logging
logging.basicConfig(level=logging.INFO)


class HomepageCatRecommendation(DataGathering, DataPreprocessing):

    def __init__(self, source=S3):
        self.data_source = source
        self.data = {}
        self.dataset = DataFrame

    def get_data(self):
        self.data_gathering()

    def preprocess_data(self):
        self.data_preprocessing(self.data)

    def model_training(self):
        self.get_data()
        self.preprocess_data()
        target = DataFrame(self.dataset[HOMEPAGE_ID].tolist(), index=self.dataset.index).to_numpy()
        features = self.dataset.drop(columns=HOMEPAGE_ID).to_numpy()
        ctl = ClassificationModel(features, target)
        model = ctl.evaluate_model()
        ctl.save_model_to_s3(model)



# #test code here
# if __name__ == "__main__":
#     ctl=HomepageCatRecommendation()
#     ctl.model_training()
