from typing import ClassVar
from graphdb import GraphDb, GraphDbConnection
from graphdb.schema import Node, Relationship
#
# connection_uri_writer = "ws://localhost:8182/gremlin"
# connection_uri_reader= "ws://localhost:8182/gremlin"

connection_uri_writer = "ws://dev-neptune-write-292706514.ap-southeast-1.elb.amazonaws.com:8183/gremlin"
connection_uri_reader = "ws://dev-neptune-376859199.ap-southeast-1.elb.amazonaws.com:8182/gremlin"

class ANGraphDb:

    def __init__(
            self,
            connection_uri_writer: str = connection_uri_writer,
            connection_uri_reader: str = connection_uri_reader
    ):
        connction_obj = GraphDbConnection.from_uri(
            connection_uri_writer=connection_uri_writer,
            connection_uri_reader=connection_uri_reader,
            pool_size=0,
            max_workers=0,
        )
        self.graph = GraphDb.from_connection(connction_obj)

    @classmethod
    def from_connection_uri(
            cls,
            connection_uri_writer: str=connection_uri_writer,
            connection_uri_reader: str=connection_uri_reader
    ) -> ClassVar:
        """Create new object based on connection uri
        :param connection_uri: string connection uri
        :return: object class
        """
        return cls(GraphDbConnection.from_uri(
            connection_uri_writer=connection_uri_writer,
            connection_uri_reader=connection_uri_reader,
            pool_size=0,
            max_workers=0,
        ))

    @classmethod
    def from_connection_class(
            cls,
            connection_class: GraphDbConnection
    ) -> ClassVar:
        """Define new class based on object connection
        :param connection_class: object connection class
        :return: object class
        """
        return cls(connection_class)

